#!/usr/bin/env python
from email.MIMEText import MIMEText
from smtplib import SMTP
import time
import random

random.seed()

class SendMail (object):
	def __init__(self, gpg=None):
		self._gpg = gpg
		self.error = None
		self._smtp = "smtp.exa-networks.co.uk"
		self._subject = None
		self._sender = None
		self._recipient = None
	
	def gpg (self,gpg):
		self._gpg = gpg
	
	def mx (self,mx):
		self._smtp = mx
	
	def smtp (self,smtp):
		self._smtp = smtp
	
	def subject (self,subject):
		self._subject = subject
	
	def sender (self,sender):
		self._sender = sender
	
	def recipient (self,recipient):
		self._recipient = recipient
	
	def send (self,message,subject=None,sender=None,recipient=None):
		if subject == None: subject = self._subject
		if sender == None: sender = self._sender
		if recipient == None: recipient = self._recipient
		
		if not recipient:
			self.error = 'No recipient'
			return False
		
		if type(recipient) == type(""):
			recipient = [recipient]
		
		for r in recipient:
			if r.count('@') != 1:
				self.error = 'recipient has no @', r
				return False
		
		if not sender:
			self.error = 'No sender'
			return False
		
		if sender.count('@') != 1:
			self.error = 'Sender has no @'
			return False
		
		if subject == None:
			self.error = 'No subject'
			return False
		
		self.error = None
		if self._gpg:
			message = self._gpg.clearsign(message)
			if self._gpg.error:
				self.error = 'could not gpg sign/encrypt the email content : ' + str(self._gpg.error)
				return False
		
		msg = MIMEText(message)
		msg['Subject'] = subject
		msg['From'] = sender
		msg['To'] = recipient[0]
		msg['Date'] = time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime())
		# The number must be unique, this not garantee a unique number but should be close enough
		r = random.randint(100000,999999)
		for c in msg['Date'] + sender + str(recipient) + subject:
			r += ord(c)
		msg['Message-ID'] = '<%s-%d@%s>' % (time.strftime("%Y%m%d-%H%M%S",time.localtime()),r,sender.split('@')[1])
		
		try:
			smtp = SMTP(self._smtp,25,self._smtp)
			smtp.sendmail(sender,recipient,msg.as_string())
			smtp.close()
		except Exception, e:
			self.error = e.args
			return False
		
		return True
	

if __name__ == "__main__":
	mail = SendMail()
	mail.send(
		"Test message\n:-)\n\nThomas",
		"Test email",
		"user@domain.com",
		"user@domain.com"
	)
	if mail.error:
		print "issue sending : ",mail.error
	else:
		print "sent"
