from vmailmgr.reader import Reader

class Decoder (Reader):
	def __init__ (self,obj):
		Reader.__init__(self,obj)
	
	def check_version (self,v):
		if v != 2:
			raise 'XXX: we should not raise a string, wrong version number'
	
	def check_args (self,size,argcount,args):
		nb = 1
		for n in range(argcount+1):
			nb += len(args[n]) + 2
		
		if nb != size:
			raise 'XXX: we should not raise a string, wrong param count %s %s %s' % ( str(nb), str(size), str(arg) )
	
	def decode_command (self,n):
		args = []
		args.append(self.read_str())
		for c in range(n):
			args.append(self.read_str())
		return args
	
	def decode_message (self):
		version = self.read_char()
		size = self.read_int()
		argcount = self.read_char()

		self.check_version(version)

		args = self.decode_command(argcount)
		self.check_args(size,argcount,args)
		
		return args
	
	def decode_response (self):
		try:
			code = self.read_char()
			if code > 0:
				msg = self.read_str()
			else:
				msg = self.read_eof()
			return code, msg
		except:
			return 3,'Server aborted the connection'
	
