from struct import pack,unpack

class Parser (object):
	def __init__ (self,stream_in):
		self.stream(stream_in)
	
	def stream (self,stream_in):
		self.si = stream_in
		self.seen = ""
	
	def read (self,n):
		s = self.si.recv(n)
		self.seen += s
		return s
	
	def read_header (self):
		header = self.read(4)
		return unpack('!BHB',header)
	
	def read_string (self):
		size = unpack('!H',self.read(2))[0]
		string = unpack('!%ds'%size,self.read(size))[0]
		return string
	
	def read_command (self):
		version,size,arguments = self.read_header()
		
		if version != 2:
			raise 'XXX: we should not raise a string, wrong version number'
		
		arg = []
		arg.append(self.read_string())
		for c in range(arguments):
			arg.append(self.read_string())
		
		nb = 1
		for n in range(arguments+1):
			nb += len(arg[n]) + 2
		
		if nb != size:
			raise 'XXX: we should not raise a string, wrong param count %s %s %s' % ( str(nb), str(size), str(arg) )
		
		return arg
		
	def read_response (self):
		try:
			r = self.read(3)
			code,size = unpack('!BH',r)
			if size > 0:
				msg = unpack('!%ds'%size,self.read(size))[0]
			else:
				msg = None
			return code,msg
		except:
			return 3,'Issue with server connection'
		
